package Source::Repository::Interface;

use strict;
use warnings;

our $VERSION=0.002;
our $verbose=0;

# protected; should not be called outside the module
sub new {
    my $proto=shift;
    my $class=ref($proto) || $proto;
    my $self = {
	@_,
    };
    bless($self,$class);
    return $self;
}

# protected; should not be called outside the module
sub create_repo_from_dir { ... }
# protected; should not be called outside the module
sub create_repo_from_file { ... }
# protected; should not be called outside the module
sub create_repo_from_url { ... }

# required by file2pkg, name2pkg
sub get_package_class {
    return 'Source::Package';
}

# required by Chain
sub get_comparator {
    my $self=shift;
    ...
}

# used in Source/Repository/Mass.pm for --all option
sub all_names_ref {
    my ($self)=@_;
    ...
}

sub name2pkg {
    my ($self,$name)=@_;
    ...
}

# TODO: why in Mass? Redesign the Mass to use proper Source::Package objects?
sub is_pkg {
    my ($self,$item)=@_;
    ...;
    return (defined($item) and -e $item and not -d $item);
}

# TODO: why in Mass? 
sub file2pkg {
    ...
}

1;
